namespace TRIXI;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Windows.Forms,
  System.ComponentModel,
  System.Runtime.InteropServices;

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
    method button1_Click(sender: System.Object; e: System.EventArgs);
    method button3_Click(sender: System.Object; e: System.EventArgs);
    method button4_Click(sender: System.Object; e: System.EventArgs);
    method button5_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method Connect(Server: string; Port: Integer): Boolean; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method Disconnect(): Boolean; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method IsOnline(): Boolean; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method WriteString(Variable: Integer; Value: String): Boolean; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method WriteInteger(Variable: Integer; Value: Integer): Integer; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method WriteFloat(Variable: Integer; Value: Double): Integer; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method WriteBoolean(Variable: Integer; Value: Boolean): Integer; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method ReadString(Variable: Integer): String; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method ReadInteger(Variable: Integer): Integer; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method ReadFloat(Variable: Integer): Double; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method ReadBoolean(Variable: Integer): Boolean; external;
    [DllImport('TRIXI.dll', Charset := Charset.Ansi, CallingConvention := CallingConvention.StdCall)]
    class method RunScript(Script: Integer): Integer; external;

  end;

implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.button1_Click(sender: System.Object; e: System.EventArgs);
begin
  if Connect(TextBox1.Text, 82) then
    MessageBox.Show('Connected') 
  else
    MessageBox.Show('Fail');
end;

method MainForm.button3_Click(sender: System.Object; e: System.EventArgs);
var ID: Integer;
begin
  ID:=Integer.Parse(TextBox3.Text);  
  WriteString(ID, TextBox2.Text);
end;

method MainForm.button4_Click(sender: System.Object; e: System.EventArgs);
var ID: Integer;
begin
  ID:=Integer.Parse(TextBox3.Text);  
  MessageBox.Show(ReadString(ID));
end;

method MainForm.button5_Click(sender: System.Object; e: System.EventArgs);
begin
  if isOnline() then
    Label3.Text:='Online'
  else
    Label3.Text:='Offline';
end;

end.