//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>


#pragma hdrstop

#include <tchar.h>
//---------------------------------------------------------------------------

#pragma argsused

typedef bool (* Connect)(LPCSTR, long);
typedef bool (* Disconnect)();
typedef long (* WriteString)(long, LPCSTR);
typedef Double (* ReadFloat)(long);

int _tmain(int argc, _TCHAR* argv[])
{
  Connect ips_connect;
  Disconnect ips_disconnect;
  WriteString ips_writestring;
  ReadFloat ips_readfloat;

  long ecode; // Errorcode

  bool result;
  bool fFreeResult;

  char IP[] = "127.0.0.1";
  char Msg[] = "C++ Test";

  // DLL Datei laden
  HINSTANCE hTRIXI = LoadLibrary("TRIXI.dll");

  if (hTRIXI)
  {
	// Die Einsprungadresse abfragen
	ips_connect = (Connect) GetProcAddress(hTRIXI, "Connect");
	ips_disconnect = (Disconnect) GetProcAddress(hTRIXI, "Disconnect");
	ips_writestring = (WriteString) (void(__stdcall*)(int))GetProcAddress(hTRIXI,"WriteString");
	ips_readfloat = (ReadFloat) (int) GetProcAddress(hTRIXI,"ReadFloat");


	// Die Funktion aufrufen
	if (ips_connect)
	{
	  char *pIP = IP;
	  result = ips_connect(pIP, 82);
	}

	if (result)
	{
	  printf("Connect OK\n");
	  char *pMsg = Msg;
	  ecode = ips_writestring(28547, pMsg);     // IPS VarID, Value als Pointer
	  printf("Variable lesen: %4.5f \n", ips_readfloat(27006));

	  if (ecode == 0)  // 0 heisst OK
	  {
		printf("Var was written successfully\n");
	  }
	  else
	  {
		printf("Some error occoured while writing to IPS. (%d)\n", ecode);
	  }
	}
	else
	{
	  printf("Fehler: Konnte die Funktion nicht aufrufen\n");
	  system("PAUSE");
	  return 1;
	}

	// Verbindung trennen und DLL-Datei wieder freigeben
	ips_disconnect();
	fFreeResult = FreeLibrary(hTRIXI);
	system("PAUSE");
	return 0;
  }
}
//---------------------------------------------------------------------------


