unit TRIXI;

interface

type TRIXI_RESULT = Integer;

const
  TR_OKAY       = 0;
  TR_FAIL       = 100;
  TR_NOT_FOUND  = 101;
  TR_OFFLINE    = 102;
  TR_EXCEPTION  = 200;

type
  TSimpleVarCallback = procedure(ID: Integer); stdcall;
  TVarCallback = procedure(ID: Integer; Time: Double; Value: PAnsiChar); stdcall;


function Connect(Server: PAnsiChar; Port: Integer): Boolean; stdcall external 'TRIXI.DLL';
function ConnectEx(Server: PAnsiChar; Port: Integer; UseSSL: Boolean; User: PAnsiChar; Pass: PAnsiChar): Boolean; stdcall external 'TRIXI.DLL';
function Disconnect(): Boolean; stdcall external 'TRIXI.DLL';
function IsOnline(): Boolean; stdcall external 'TRIXI.DLL';
procedure WriteDebugFile(FilePath: PAnsiChar; MsgSink: Boolean); stdcall external 'TRIXI.DLL';

procedure SetSimpleVarCallback(Value: TSimpleVarCallback); stdcall external 'TRIXI.DLL';
procedure SetVarUpdateCallback(Value: TVarCallback); stdcall external 'TRIXI.DLL';
procedure SetVarChangeCallback(Value: TVarCallback); stdcall external 'TRIXI.DLL';

function WriteString(Variable: Integer; Value: PAnsiChar): TRIXI_RESULT; stdcall external 'TRIXI.DLL';
function WriteInteger(Variable: Integer; Value: Integer): TRIXI_RESULT; stdcall external 'TRIXI.DLL';
function WriteFloat(Variable: Integer; Value: Double): TRIXI_RESULT; stdcall external 'TRIXI.DLL';
function WriteBoolean(Variable: Integer; Value: Boolean): TRIXI_RESULT; stdcall external 'TRIXI.DLL';
function ReadString(Variable: Integer): PAnsiChar; stdcall external 'TRIXI.DLL';
function ReadInteger(Variable: Integer): Integer; stdcall external 'TRIXI.DLL';
function ReadFloat(Variable: Integer): Double; stdcall external 'TRIXI.DLL';
function ReadBoolean(Variable: Integer): Boolean; stdcall external 'TRIXI.DLL';
function RunScript(Variable: Integer): TRIXI_RESULT; stdcall external 'TRIXI.DLL';

function GetScriptIDByName(Script: PAnsiChar; ParentID: Integer): Integer; stdcall external 'TRIXI.DLL';
function GetVariableIDByName(Variable: PAnsiChar; ParentID: Integer): Integer; stdcall external 'TRIXI.DLL';
function VariableExists(VariableID: Integer): Boolean; stdcall external 'TRIXI.DLL';
function ScriptExists(ScriptID: Integer): Boolean; stdcall external 'TRIXI.DLL';

implementation

end.
